"use strict";

/**
 * Definitions - Lodash and Custom
 * - First value is always chained
 * - Categorized by "is" (checkers), "to" (casters), and "fn" (just functions)
 */
const _ = require("lodash");



/**
 * Lodash Functions
 * - First argument is of the specific type
 * - Will throw if attempted to use with a value not of the proper type
 */
const arrayMethods = `
  chunk compact concat cond difference differenceBy differenceWith drop dropRight dropRightWhile dropWhile fill findIndex
  findLastIndex flatten flattenDeep flattenDepth flow flowRight fromPairs head indexOf initial intersection intersectionBy intersectionWith
  join last lastIndexOf max maxBy mean meanBy min minBy nth over overEvery overSome pull pullAll pullAllBy pullAllWith pullAt remove reverse slice
  sortedIndex sortedIndexBy sortedIndexOf sortedLastIndex sortedLastIndexBy sortedLastIndexOf sortedUniq sortedUniqBy sum sumBy
  tail take takeRight takeRightWhile takeWhile union unionBy unionWith uniq uniqBy uniqWith unzip unzipWith without xor xorBy
  xorWith zip zipObject zipObjectDeep zipWith
`.split(/\s/).filter(m => !!m);

const collectionMethods = `
  countBy each eachRight every filter find findLast flatMap flatMapDeep flatMapDepth forEach forEachRight groupBy includes
  invokeMap keyBy map orderBy partition reduce reduceRight reject sample sampleSize shuffle size some sortBy`;

const functionMethods = `
  after ary attempt before bind bindKey curry curryRight debounce defer delay flip memoize
  negate once overArgs partial partialRight rearg rest spread throttle unary wrap`;

const numberMethods = `
  add ceil clamp divide floor inRange multiply nthArg random range rangeRight round subtract`;

const objectMethods = `
  assign assignIn assignInWith assignWith at bindAll conforms conformsTo create extend defaults defaultsDeep entries entriesIn extend extendWith
  findKey findLastKey forIn forInRight forOwn forOwnRight functions functionsIn get has hasIn invert invertBy invoke
  keys keysIn mapKeys mapValues matches merge mergeWith methodOf omit omitBy pick pickBy propertyOf result set setWith toPairs toPairsIn
  transform unset update updateWith values valuesIn`;

const stringMethods = `
  camelCase capitalize deburr endsWith escape escapeRegExp kebabCase lowerCase lowerFirst pad padEnd padStart parseInt
  repeat replace snakeCase split startCase startsWith template toLower toUpper trim trimEnd trimStart truncate unescape uniqueId upperCase upperFirst words`;

const anyMethods = `
  castArray clone cloneDeep cloneDeepWith cloneWith constant defaultTo eq gt gte identity iteratee lt lte`;

const arrayStringMethods = `
  matchesProperty method property `;

let modifiers = {};



module.exports = modifiers;
