
/**
 * Custom Functions and Types
 */
const custom = {

  arguments: {
    is: _.isArguments
  },

  array: {
    is: _.isArray,
    to: _.toArray // slice arguments too
  },

  boolean: {
    is: _.isBoolean,
    to (value) {
      //TODO
    }
  },

  date: {
    is: _.isDate,
    to (value) {
      //TODO
    }
  },

  element: {
    is: _.isElement
  },

  error: {
    is: _.isError,
    to (value) {
      //TODO
    }
  },

  function: {
    is: _.isFunction,
    to (value) {
      //TODO
    }
  },

  integer: {
    is: _.isInteger,
    to: _.toInteger
  },

  null: {
    is: _.isNull,
    to () {
      return null;
    }
  },

  number: {
    is: _.isNumber,
    to: _.toNumber
  },

  object: {
    is (value, def) {
      return _.isObject(value);
    },
    to (value, def) {
      //TODO
    }
  },

  regExp: {
    is: _.isRegExp,
    to (value) {
      //TODO
    }
  },

  string: {
    is: _.isString,
    to: _.toString
  },

  undefined: {
    is: _.isUndefined,
    to () {
      return;
    }
  }

};



var niceToHaves = {

  arrayBuffer: {
    is: _.isArrayBuffer
  },

  arrayLike: {
    is: _.isArrayLike
  },

  arrayLikeObject: {
    is: _.isArrayLikeObject
  },

  buffer: {
    is: _.isBuffer,
    to (value) {
      //TODO
    }
  },

  empty: {
    is: _.isEmpty,
    to (value) {
      //TODO
    }
  },

  finite: {
    is: _.isFinite,
    to: _.toFinite
  },

  length: {
    is: _.isLength,
    to: _.toLength
  },

  map: {
    is: _.isMap,
    to (value) {
      //TODO
    }
  },

  NaN: {
    is: _.isNaN,
    to () {
      return Math.NaN;
    }
  },

  objectLike: {
    is: _.isObjectLike
  },

  plainObject: {
    is: _.isPlainObject,
    to: _.toPlainObject
  },

  safeInteger: {
    is: _.isSafeInteger,
    to: _.toSafeInteger
  },

  set: {
    is: _.isSet,
    to (value) {
      //TODO
    }
  },

  symbol: {
    is: _.isSymbol,
    to (value) {
      //TODO
    }
  },

  typedArray: {
    is: _.isTypedArray
  },

  weakMap: {
    is: _.isWeakMap
  },

  weakSet: {
    is: _.isWeakSet
  }

};